QuattroDosSpreadsheet Class Reference documentation

Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
QuattroDosSpreadsheet Class Reference

This class parses Quattro Pro DOS spreadsheet file. More...

`#include <QuattroDosSpreadsheet.h>`

## Public Member Functions
| QuattroDosSpreadsheet (QuattroDosParser &parser)
| constructor More...
| ~QuattroDosSpreadsheet ()
| destructor More...
void | setListener (WKSContentListenerPtr &listen)
| sets the listener More...

## Protected Member Functions
bool | checkFilePosition (long pos)
| return true if the pos is in the file, update the file size if need More...
int | version () const
| return the file version More...
bool | hasLICSCharacters () const
| returns the true if the file has LICS characters More...
int | getNumSpreadsheets () const
| returns the number of spreadsheet More...
librevenge::RVNGString | getSheetName (int id) const
| returns the name of the id's spreadsheet More...
void | sendSpreadsheet (int sId, std::map< Vec2i, Vec2i > const &chartCellMap)
| send the sId'th spreadsheet More...
void | sendCellContent (QuattroDosSpreadsheetInternal::Cell const &cell, int cellChartSheetId=-1, Vec2f const &chartSize=Vec2f())
| send the cell data More...
bool | readSpreadsheetOpen ()
| reads a sheet header zone 0:dc (Quattro Pro wq2) More...
bool | readSpreadsheetClose ()
| reads a sheet header zone 0:dd (Quattro Pro wq2) More...
bool | readCell ()
| reads a cell content data More...
bool | readCellFormulaResult ()
| reads the result of a text formula More...
bool | readSheetSize ()
| reads sheet size More...
bool | readSpreadsheetName ()
| reads a sheet name (zone 0xde), unused... More...
bool | readColumnSize ()
| reads the column size ( in ??? ) More...
bool | readRowSize ()
| reads the column size ( in points ) More...
bool | readHiddenColumns ()
| reads the list of hidden columns zone ( unused ) More...
bool | readCellProperty ()
| reads a Quattro Pro property (zone 0x9d) More...
bool | readCellStyle ()
| reads a Quattro Pro cell styles (zone 0xd8) More...
bool | readUserStyle ()
| reads a Quattro Pro style ( zone 0xc9) More...
bool | readCell (Vec2i actPos, WKSContentListener::FormulaInstruction &instr, bool hasSheetId=false, int sheetId=0)
bool | readFormula (long endPos, Vec2i const &pos, int sheetId, std::vector< WKSContentListener::FormulaInstruction > &formula, std::string &error)

## Private Member Functions
| QuattroDosSpreadsheet (QuattroDosSpreadsheet const &orig)=delete
QuattroDosSpreadsheet & | operator= (QuattroDosSpreadsheet const &orig)=delete
libwps::DebugFile & | ascii ()
| returns the debug file More...

## Private Attributes
RVNGInputStreamPtr | m_input
| the input More...
std::shared_ptr< WKSContentListener > | m_listener
QuattroDosParser & | m_mainParser
| the listener (if set) More...
std::shared_ptr< QuattroDosSpreadsheetInternal::State > | m_state
| the internal state More...
libwps::DebugFile & | m_asciiFile
| the ascii file More...

## Friends
class | QuattroDosParser

## Detailed Description

This class parses Quattro Pro DOS spreadsheet file.

## Constructor & Destructor Documentation

## ◆ QuattroDosSpreadsheet() [1/2]

QuattroDosSpreadsheet::QuattroDosSpreadsheet | ( | QuattroDosParser & | parser | ) |
| explicit

constructor

## ◆ ~QuattroDosSpreadsheet()

QuattroDosSpreadsheet::~QuattroDosSpreadsheet | ( |  | ) |

destructor

## ◆ QuattroDosSpreadsheet() [2/2]

QuattroDosSpreadsheet::QuattroDosSpreadsheet | ( | QuattroDosSpreadsheet const & | orig | ) |
| privatedelete

## Member Function Documentation

## ◆ ascii()

libwps::DebugFile& QuattroDosSpreadsheet::ascii | ( |  | ) |
| inlineprivate

returns the debug file

Referenced by readCell(), readCellFormulaResult(), readCellProperty(), readCellStyle(), readColumnSize(), readFormula(), readHiddenColumns(), readRowSize(), readSheetSize(), readSpreadsheetClose(), readSpreadsheetName(), readSpreadsheetOpen(), and readUserStyle().

## ◆ checkFilePosition()

bool QuattroDosSpreadsheet::checkFilePosition | ( | long | pos | ) |
| protected

return true if the pos is in the file, update the file size if need

## ◆ getNumSpreadsheets()

int QuattroDosSpreadsheet::getNumSpreadsheets | ( |  | ) | const
| protected

returns the number of spreadsheet

## ◆ getSheetName()

librevenge::RVNGString QuattroDosSpreadsheet::getSheetName | ( | int | id | ) | const
| protected

returns the name of the id's spreadsheet

## ◆ hasLICSCharacters()

bool QuattroDosSpreadsheet::hasLICSCharacters | ( |  | ) | const
| protected

returns the true if the file has LICS characters

Referenced by sendCellContent().

## ◆ operator=()

QuattroDosSpreadsheet& QuattroDosSpreadsheet::operator= | ( | QuattroDosSpreadsheet const & | orig | ) |
| privatedelete

## ◆ readCell() [1/2]

bool QuattroDosSpreadsheet::readCell | ( |  | ) |
| protected

reads a cell content data

Referenced by readFormula().

## ◆ readCell() [2/2]

bool QuattroDosSpreadsheet::readCell | ( | Vec2i | actPos,
|  | WKSContentListener::FormulaInstruction & | instr,
|  | bool | hasSheetId = `false`,
|  | int | sheetId = `0`
| ) |  |
| protected

## ◆ readCellFormulaResult()

bool QuattroDosSpreadsheet::readCellFormulaResult | ( |  | ) |
| protected

reads the result of a text formula

## ◆ readCellProperty()

bool QuattroDosSpreadsheet::readCellProperty | ( |  | ) |
| protected

reads a Quattro Pro property (zone 0x9d)

## ◆ readCellStyle()

bool QuattroDosSpreadsheet::readCellStyle | ( |  | ) |
| protected

reads a Quattro Pro cell styles (zone 0xd8)

## ◆ readColumnSize()

bool QuattroDosSpreadsheet::readColumnSize | ( |  | ) |
| protected

reads the column size ( in ??? )

## ◆ readFormula()

bool QuattroDosSpreadsheet::readFormula | ( | long | endPos,
|  | Vec2i const & | pos,
|  | int | sheetId,
|  | std::vector< WKSContentListener::FormulaInstruction > & | formula,
|  | std::string & | error
| ) |  |
| protected

Referenced by readCell().

## ◆ readHiddenColumns()

bool QuattroDosSpreadsheet::readHiddenColumns | ( |  | ) |
| protected

reads the list of hidden columns zone ( unused )

## ◆ readRowSize()

bool QuattroDosSpreadsheet::readRowSize | ( |  | ) |
| protected

reads the column size ( in points )

## ◆ readSheetSize()

bool QuattroDosSpreadsheet::readSheetSize | ( |  | ) |
| protected

reads sheet size

## ◆ readSpreadsheetClose()

bool QuattroDosSpreadsheet::readSpreadsheetClose | ( |  | ) |
| protected

reads a sheet header zone 0:dd (Quattro Pro wq2)

## ◆ readSpreadsheetName()

bool QuattroDosSpreadsheet::readSpreadsheetName | ( |  | ) |
| protected

reads a sheet name (zone 0xde), unused...

## ◆ readSpreadsheetOpen()

bool QuattroDosSpreadsheet::readSpreadsheetOpen | ( |  | ) |
| protected

reads a sheet header zone 0:dc (Quattro Pro wq2)

## ◆ readUserStyle()

bool QuattroDosSpreadsheet::readUserStyle | ( |  | ) |
| protected

reads a Quattro Pro style ( zone 0xc9)

## ◆ sendCellContent()

void QuattroDosSpreadsheet::sendCellContent | ( | QuattroDosSpreadsheetInternal::Cell const & | cell,
|  | int | cellChartSheetId = `-1`,
|  | Vec2f const & | chartSize = `Vec2f()`
| ) |  |
| protected

send the cell data

Referenced by sendSpreadsheet().

## ◆ sendSpreadsheet()

void QuattroDosSpreadsheet::sendSpreadsheet | ( | int | sId,
|  | std::map< Vec2i, Vec2i > const & | chartCellMap
| ) |  |
| protected

send the sId'th spreadsheet

## ◆ setListener()

void QuattroDosSpreadsheet::setListener | ( | WKSContentListenerPtr & | listen | ) |
| inline

sets the listener

## ◆ version()

int QuattroDosSpreadsheet::version | ( |  | ) | const
| protected

return the file version

Referenced by readCell(), readCellFormulaResult(), readCellStyle(), readFormula(), readSheetSize(), and readUserStyle().

## Friends And Related Function Documentation

## ◆ QuattroDosParser

friend class QuattroDosParser
| friend

## Member Data Documentation

## ◆ m_asciiFile

libwps::DebugFile& QuattroDosSpreadsheet::m_asciiFile
| private

the ascii file

Referenced by ascii().

## ◆ m_input

RVNGInputStreamPtr QuattroDosSpreadsheet::m_input
| private

the input

Referenced by checkFilePosition(), readCell(), readCellFormulaResult(), readCellProperty(), readCellStyle(), readColumnSize(), readFormula(), readHiddenColumns(), readRowSize(), readSheetSize(), readSpreadsheetClose(), readSpreadsheetName(), readSpreadsheetOpen(), readUserStyle(), and sendCellContent().

## ◆ m_listener

std::shared_ptr<WKSContentListener> QuattroDosSpreadsheet::m_listener
| private

Referenced by sendCellContent(), sendSpreadsheet(), and setListener().

## ◆ m_mainParser

QuattroDosParser& QuattroDosSpreadsheet::m_mainParser
| private

the listener (if set)

the main parser

Referenced by hasLICSCharacters(), readCell(), readCellFormulaResult(), readCellProperty(), readCellStyle(), readSpreadsheetName(), readUserStyle(), sendCellContent(), sendSpreadsheet(), and version().

## ◆ m_state

std::shared_ptr<QuattroDosSpreadsheetInternal::State> QuattroDosSpreadsheet::m_state
| private

the internal state

Referenced by checkFilePosition(), getNumSpreadsheets(), getSheetName(), hasLICSCharacters(), readCell(), readCellProperty(), readCellStyle(), readColumnSize(), readRowSize(), readSheetSize(), readSpreadsheetClose(), readSpreadsheetOpen(), readUserStyle(), sendSpreadsheet(), and version().

The documentation for this class was generated from the following files:

- QuattroDosSpreadsheet.h
- QuattroDosSpreadsheet.cpp